// OpenSCAD, free download on www.openscad.org
// Copy the following program to OpenSCAD, press F5, F6 and then export STL file for your CAM program and 3D printer.
// Look for help in the OpenSCAD documentation and then on the author's email: ok1ven@email.cz.

                    // Plate dimensions:
thicknessBody=4;    // Thickness
length=42;          // 18 x 25 mm
height=25;          // Total length 42 mm
width=18;

                    // Ring dimensions:
thicknessWheel=8;   // Thickness 8 mm
diameter1=10;       // Internal diameter, bearings
diameter2=16.7;     // External diameter

radius2=2;          // Radius 2 mm

$fn=160;            // Only setup of rendering, number of segments (fine surface)

                    //  Drawing:

fingerboard(width,height); // Main plate

translate([0,length-diameter2/2,diameter2/2]) rotate([0,90,0])  // Wheel
         difference(){
                      translate([0,0,0]) cylinder(d=diameter2,thicknessWheel);    // Ring
                      translate([0,0,0]) cylinder(d=diameter1,thicknessWheel);    // Hole
                     }

difference(){   // Piece 1, horizontal connection between the plate and the ring
             translate([0,height-1,0]) cube([thicknessWheel,length-height+1-diameter2/2,thicknessBody]);
             translate([0,length-diameter2/2,diameter2/2]) rotate([0,90,0]) cylinder(d=diameter1,thicknessWheel);
            }

                // Piece 2, vertical connection
translate([0,length-diameter2,thicknessBody]) cube([thicknessWheel,(diameter2-diameter1)/2,diameter2/2-thicknessBody]);

difference(){   // Piece 3, vertical curve
             translate([0,length-diameter2-radius2,thicknessBody]) cube([thicknessWheel,radius2,radius2]); // Material addition
             translate([0,length-diameter2-radius2,thicknessBody+radius2]) rotate([0,90,0]) cylinder(r=radius2,thicknessWheel); // Rounding
            }


module fingerboard(ww,hh){
  difference(){
               translate([0,0,0]) cube([ww,hh,thicknessBody]);                              // Body
      
               translate([0,0,0]) cube([radius2,radius2,thicknessBody]);                    // Cut piece 1 LD
               translate([ww-radius2,0,0]) cube([radius2,radius2,thicknessBody]);           // Cut piece 2 RD
               translate([ww-radius2,hh-radius2,0]) cube([radius2,radius2,thicknessBody]);  // Cut piece 3 RU
              }
              
               translate([radius2,radius2,0]) cylinder(r=radius2,thicknessBody);            // Curve 1 LD, Rounding
               translate([ww-radius2,radius2,0]) cylinder(r=radius2,thicknessBody);         // Curve 2 RD
               translate([ww-radius2,hh-radius2,0]) cylinder(r=radius2,thicknessBody);      // Curve 3 RU
                         }
